package others;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.LineIterator;

public class find_wiki_rel {
    static String datapath = "/media/sdc/Wikipedia/latest-all.json";
    static String basepath = "/media/sda3/veritas/Wikipedia/new_experiment/EXP1/";
    static String titlepath = basepath+"Final_result.txt";
    static String contentpath = basepath+ "Wikidata_result/wikidata_matched_subset.txt";
    static String resultpath = basepath + "Wikidata_result/wikidata_match_result.txt";
    static String justresultcontentpath = basepath + "Wikidata_result/wikidata_matched_subset_ONLYfromFinal_result.txt";
    static String justdisocontentpath = basepath + "Wikidata_result/wikidata_matched_subset_ONLYfromDISOofFinal_result.txt";
    static String justdisoreltitle = basepath + "Wikidata_result/Wikidata_RELfromDISOofFinal_result.txt";
    static String resttitlepath = basepath + "Wikidata_result/TITLE_of_Final_result_NoCOR_Wikipage_in_wikidata.txt";
    static String writelogpath = basepath +"log.txt";
public static String find_rel(char[] text) throws Exception{
        int len = text.length;
        int i=0;
        String result_string = "";
        HashSet<String> pidset = new HashSet<String>();
        pidset.add("P828");
        pidset.add("P1542");//has effect
        pidset.add("P689");//afflicts
        pidset.add("P1995");//health specialty
        pidset.add("P780");//symptoms
        pidset.add("P2176");
        pidset.add("P2293");
        pidset.add("P373");
        pidset.add("P910");
        pidset.add("P5642");
        pidset.add("P279");
        pidset.add("P31");
        pidset.add("P923");
        pidset.add("P924");
        pidset.add("P927");
        pidset.add("P2854");
        pidset.add("P1880"); 
        pidset.add("P1060"); 
        pidset.add("P138");
    
        boolean locate_flag = false;
        while(i<len){if(text[i]=='"'&&text[i+1]=='c'&&text[i+2]=='l'&&text[i+3]=='a'&&text[i+4]=='i'&&text[i+5]=='m'&&text[i+6]=='s'&&text[i+8]==':'&&text[i+9]=='{'){
                i=i+9;
                locate_flag = true;
                break;
            }
            i++;
        }
        int j =0;
        if(locate_flag){
            int brace = 1;
            int brackets = 0;
            while(i<len-1&&brace!=0){
                i++;
                if(text[i]=='{')brace++;
                else if(text[i]=='}')brace--;
                else{
                    if(text[i]=='"'&&text[i+1]=='P'){
                        j=i+2;
                        i++;
                        while(j<len&&text[j]!='"'){
                            j++;
                        }
                        char[] temp = new char[j-i];
                        for(int k=0;k<temp.length;k++){
                            temp[k]=text[i+k];
                        }
                        String pid = new String(temp);
                        i = j+1;
                        if(text[i]!=':')System.err.println("ERROR!");
                        i++;
                        if(text[i]!='[')System.err.println("ERROR!");
                        if(text[i]=='['){
                            brackets = 1;
                            j = i+1;
                            if(pidset.contains(pid)){
                                //System.out.println(pid);
                                result_string =result_string+"\t"+pid+"|";
                            while(i<len-1&&brackets>0){
                                i++;
                                if(text[i]=='[')brackets++;
                                else if(text[i]==']')brackets--;
                                else{
                                    if(text[i]=='"'&&text[i+1]=='m'&&text[i+2]=='a'&&text[i+3]=='i'&&text[i+4]=='n'&&text[i+5]=='s'&&text[i+6]=='n'&&text[i+7]=='a'&&text[i+8]=='k'&&text[i+9]=='"'){
                                        i=i+9;
                                        while(i<len&&brackets>0){
                                            i++;
                                            if(text[i]=='[')brackets++;
                                            else if(text[i]==']')brackets--;
                                            else{
                                                if(text[i]=='"'&&text[i+1]=='Q'){
                                                    j=i+2;
                                                    i++;
                                                    while(j<len&&text[j]!='"'){
                                                    j++;
                                                    }
                                                    temp = new char[j-i];
                                                    for(int k=0;k<temp.length;k++){
                                                    temp[k]=text[i+k];
                                                    }
                                                    result_string = result_string+new String(temp)+" ";
                                                    i = j;
                                                    break;
                                                }
                                            }
                                        }
                                        
                                    }
                                
                                }
                            }
                            }else{
                                while(i<len-1&&brackets>0){
                                    i++;
                                    if(text[i]=='[')brackets++;
                                    else if(text[i]==']')brackets--;
                                }
                                
                            }
                        }
                    }
                }
            }
        }
        return result_string;
    }
    

    public static void main(String[] args){
        HashSet<String> titleset = new HashSet<String>();
        HashMap<String,String> title2sty = new HashMap<String,String>();
        String errorstring = null;
        PrintWriter writelog = null;//new PrintWriter(writelogpath);
        try{
            //PrintWriter writelog = new PrintWriter(new OutputStreamWriter(new FileOutputStream(writelogpath),"UTF-8"));
            InputStreamReader isr1 = new InputStreamReader(new FileInputStream(titlepath),"UTF-8");
            BufferedReader br = new BufferedReader(isr1);
            String s = null;
            while((s = br.readLine())!= null){
                //System.out.println(s);
                String[] item = s.split("\t");
                String temp = item[0].replaceAll("_", " ");
                titleset.add(temp);
                title2sty.put(temp, item[2]);
            }
            br.close();
        }catch (IOException e) {  
            // TODO Auto-generated catch block  
            e.printStackTrace();  
        } 

        try {  
            
            LineIterator it = FileUtils.lineIterator(new File(datapath),"UTF-8");
            PrintWriter write_content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(contentpath),"UTF-8"));
            PrintWriter write_result_content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(justresultcontentpath),"UTF-8"));
            PrintWriter write_diso_content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(justdisocontentpath),"UTF-8"));
            PrintWriter write_diso_title = new PrintWriter(new OutputStreamWriter(new FileOutputStream(justdisoreltitle),"UTF-8"));
            PrintWriter write_rest_title = new PrintWriter(new OutputStreamWriter(new FileOutputStream(resttitlepath),"UTF-8"));
            PrintWriter write1 = new PrintWriter(new OutputStreamWriter(new FileOutputStream(resultpath),"UTF-8"));
            //PrintWriter writelog = new PrintWriter(new OutputStreamWriter(new FileOutputStream(writelogpath),"UTF-8"));
            writelog = new PrintWriter(new OutputStreamWriter(new FileOutputStream(writelogpath),"UTF-8"));
            String s = null;  
            int count = 0;
            write_content.write("[\n");
            while (it.hasNext()) {
               s = it.nextLine();
                count = count + 1;
                //System.out.println(s);  
                int len = s.length();
                errorstring = s;
                if(len<10)continue;
                char[] text = s.toCharArray();
                int j = 5;
                int k = 0;
                boolean is_id = false;
                boolean is_in = false;
                boolean in_result = false;
                boolean nulltitle = true;
                String idd = null;
                String type = "";
                String  titlee = null;
                while(j<len-9){
                    j++;
                    //System.out.println("=="+text[j]+"==");
                    
                    if(!is_id){
                        if(text[j-1]=='"'&&text[j]=='i'&&text[j+1]=='d'&&text[j+2]=='"'&&text[j+3]==':'){
                            //System.out.println("hello");
                            j = j + 5;
                            k = j;
                            while(text[j]!='"'){
                                j++;
                            }
                            //System.out.println("j"+j+"k"+k);
                            char[] id = new char[j - k];
                            for(int i = 0; i < j-k; i++){
                                id[i] = text[k+i];
                            }
                            idd = new String(id);
                            is_id = true;
                            //System.out.println(idd);
                        }
                    }//end if  extract id
                    if(text[j]=='P'&&text[j-1]=='"'&&text[j+5]=='"'){
            			j = j + 1;
            			if(text[j]=='2'&&text[j+1]=='8'&&text[j+2]=='9'&&text[j+3]=='2'){
            				is_in = true;
            				type = type+"_UMLS";
            			}
            			else if(text[j]=='4'&&text[j+1]=='2'&&text[j+2]=='2'&&text[j+3]=='9'){
            				is_in = true;
            				type = type+"_ICD10CM";
            			}
            			else if(text[j]=='3'&&text[j+1]=='3'&&text[j+2]=='4'&&text[j+3]=='5'){
            				is_in = true;
            				type = type+"_RxNorm";
            			}
            			else if(text[j]=='2'&&text[j+1]=='1'&&text[j+2]=='1'&&text[j+3]=='5'){
            				is_in = true;
            				type = type+"_NDF-RT";
            			}
            			else if(text[j]=='4'&&text[j+1]=='3'&&text[j+2]=='3'&&text[j+3]=='8'){
            				is_in = true;
            				type = type+"_LOINC";
            			}
            			else if(text[j]=='1'&&text[j+1]=='6'&&text[j+2]=='9'&&text[j+3]=='2'){
            				is_in = true;
            				type = type+"_ICD9CM";
            			}
                        else if(text[j]=='1'&&text[j+1]=='6'&&text[j+2]=='9'&&text[j+3]=='0'){
            				is_in = true;
            				type = type+"_ICD10PCS";
            			}
            			
            		}
            		else if(text[j]=='P'&&text[j-1]=='"'&&text[j+4]=='"'){
            			j = j + 1;
            			if(text[j]=='6'&&text[j+1]=='7'&&text[j+2]=='2'){
            				is_in = true;
            				type = type+"_MeSHCODE";
            			}
                        else if(text[j]=='6'&&text[j+1]=='9'&&text[j+2]=='9'){
            				is_in = true;
            				type = type+"_DO";
            			}
                        else if(text[j]=='4'&&text[j+1]=='9'&&text[j+2]=='4'){
            				is_in = true;
            				type = type+"_ICD-10";
            			}
                        else if(text[j]=='4'&&text[j+1]=='9'&&text[j+2]=='3'){
            				is_in = true;
            				type = type+"_ICD-9";
            			}
                        
                    }
                    
                    //end P judge whether umls or others
                    //"enwiki","title":"
                    if(text[j]=='e'&&text[j+1]=='n'&&text[j+2]=='w'&&text[j+3]=='i'&&text[j+4]=='k'&&text[j+5]=='i'&&text[j+6]=='"'){
                        j= j+7;
                        if(text[j]==','&&text[j+1]=='"'&&text[j+2]=='t'&&text[j+3]=='i'&&text[j+4]=='t'&&text[j+5]=='l'&&text[j+6]=='e'){
                            j = j+7;
                            if(text[j]=='"'&&text[j+1]==':'){
                                k = j+3;
                                j = j + 3;
                                while(text[j]!='"'||text[j+1]!=','){
                                    j++;
                                }
                                char[] title = new char[j - k];
                                for(int i = 0; i < j-k; i++){
                                    title[i] = text[k+i];
                                }
                                titlee = new String(title);
                                
                                //reason: java is fed on "\\u" not something in "\u2745",  so it can't output chinese,  we need to transfer "\\u93aa" into "\u93aa"
                                //String temp = null;
                                if (titlee.contains("\\u")) {  
                                    StringBuffer buf = new StringBuffer();  
                                    Matcher m = Pattern.compile("\\\\u([0-9A-Fa-f]{4})").matcher(titlee);  
                                    while (m.find()) {  
                                        try {  
                                            int cp = Integer.parseInt(m.group(1), 16);  
                                            m.appendReplacement(buf, "");  
                                            buf.appendCodePoint(cp);  
                                        } catch (NumberFormatException e) {  
                                        }  
                                    }  
                                    m.appendTail(buf);  
                                    titlee = buf.toString();  
                                   
                                }  
                                
                                //System.out.println(titlee);
                                if(titleset.contains(titlee)){is_in = true;type = type+"_Result";in_result = true;
                                titleset.remove(titlee);}
                            }
                        }
                    }//end if title extract title
                    
                }
                if(is_in&&is_id){
                    if(titlee==null) {
                    //  System.out.println(idd);
                        //writelog.write(s+"\n");

                        j=5;
                        while(j<len-18) {
                            j++;
                            if(text[j]==':'&&text[j+1]=='"'&&text[j+2]=='e'&&text[j+3]=='n'&&text[j+4]=='"'&&text[j+5]==','&&text[j+6]=='"'&&text[j+7]=='v'&&text[j+8]=='a'&&text[j+9]=='l'&&text[j+11]=='e'&&text[j+13]==':'){
                                k = j+15;
                                j=j+14;
                                while(j<len-18) {
                                    j++;
                                    if(text[j]=='"'&&text[j+1]=='}') {
                                        char[] title = new char[j - k];
                                        for(int i = 0; i < j-k; i++){
                                            title[i] = text[k+i];
                                        }
                                        titlee = new String(title);
                                        if (titlee.contains("\\u")) {  
                                            StringBuffer buf = new StringBuffer();  
                                            Matcher m = Pattern.compile("\\\\u([0-9A-Fa-f]{4})").matcher(titlee);  
                                            while (m.find()) {  
                                                try {  
                                                    int cp = Integer.parseInt(m.group(1), 16);  
                                                    m.appendReplacement(buf, "");  
                                                    buf.appendCodePoint(cp);  
                                                } catch (NumberFormatException e) {  
                                                }  
                                            }  
                                            m.appendTail(buf);  
                                            titlee = buf.toString();  
                                           
                                        } 
                                        nulltitle = false;
                                        break;
                                    }
                                }
                                if(!nulltitle)break;
                            }
                        }
                        titlee = "null:"+titlee;
                        
                    }
                    write1.write(idd+"\t"+titlee+"\t"+type+"\n");
                    write_content.write(s+"\n");
                    if(in_result) {
                write_result_content.write(s+"\n");
                if(title2sty.get(titlee).equals("DISO")){
//System.out.println(titlee);                    
write_diso_content.write(s+"\n");
                    write_diso_title.write(idd+"\t"+titlee+"\t"+type+"\t"+find_rel(text)+"\n");
                    //System.out.println(idd+"\t"+titlee+"\t"+type+"\t"+find_rel(text));
                    //System.out.println(idd+"\t"+titlee+"\t"+type);
                    //System.out.println(find_rel(text));
                    
                }
                }

                }
                
                if(count%10000==0){
                    System.out.println(count);
                    //System.out.println(idd);
                }
            /*    if(count>20000) {
                write_content.close();
                write_diso_title.close();
                write_diso_content.close();
                write1.close();
                System.out.println(titleset.size());
                write_result_content.close();
                System.exit(1);
            }
*/
                //if(count > 10000)break;
            }
            for(String temp:titleset){
             write_rest_title.write(temp+"\n");}
             write_rest_title.close();
            write_content.write("]");
            write1.close();
             write_diso_title.close();
            write_diso_content.close();
            writelog.close();
            write_result_content.close();
            write_content.close();
            System.out.println(titleset.size());
            System.out.println(count);
        } catch (Exception e) {
            System.err.println("ERROR!");
          //  System.out.println(errorstring);
            writelog.write(errorstring+"\n");
            writelog.close();  
            // TODO Auto-generated catch block  
            e.printStackTrace();  
        }  
    }
    
}
