import sys
#reload(sys);
#sys.setdefaultencoding("utf8")

import urllib.request
import urllib.parse
import json
import collections
def getHtml(url):
    try:
        response = urllib.request.urlopen(url)
        html = response.read().decode("utf-8",'ignore')
    except:
        temp = url.split('&cmtitle=')
        temp2 = temp[1].split('&cmlimit=')
        url0 = temp[0]+'&cmtitle='+urllib.parse.quote(temp2[0])+'&cmlimit='+temp2[1]
        response = urllib.request.urlopen(url0)
        html = response.read().decode("utf-8",'ignore')
    return html

depth = 5


def get_cat_url(cat_title):
    temp = '_'.join(cat_title.split(' '))
    return("https://en.wikipedia.org/w/api.php?action=query&format=json&list=categorymembers&cmtitle=" 
    + temp+'&cmlimit=400')

count = 0
origin_cat_list = ['Category:Medicine','Category:Anatomy']
cur_crawl_list = collections.deque()
next_crawl_list = collections.deque()
url_crawled = set([])
page_obtained = set([])
for x in origin_cat_list:
    temp = get_cat_url(x)
    if temp in url_crawled:
        pass
    else:
        cur_crawl_list.append(temp)


for i_depth in range(depth-1):
    while len(cur_crawl_list) >0:
        count += 1
        if count %1000 == 0:
            print(count)
        if count >1000000:
            break
        x = cur_crawl_list.popleft()
        if x in url_crawled:
            continue
        htmlcontent_dict = json.loads(getHtml(x))
        url_crawled.add(x)
        if 'continue' in htmlcontent_dict:
            if '&cmcontinue=' in x:
                nextpageurl = x.split('&cmcontinue=')[0]+'&cmcontinue='+htmlcontent_dict['continue']['cmcontinue']
            else:
                nextpageurl = x+'&cmcontinue='+htmlcontent_dict['continue']['cmcontinue']
            if nextpageurl not in url_crawled:
                cur_crawl_list.append(nextpageurl)
        if 'query' in htmlcontent_dict:
            if 'categorymembers' in htmlcontent_dict['query']:
                for item in htmlcontent_dict['query']['categorymembers']:
                    if 'Category:' == item['title'][:9]:
                        next_depth_url = get_cat_url(item['title'])
                        if next_depth_url not in url_crawled:
                            next_crawl_list.append(next_depth_url)
                    else:
                        page_obtained.add('_'.join(item['title'].split(' '))+' '+str(item['pageid']))
    cur_crawl_list = next_crawl_list.copy()
    next_crawl_list.clear()



while len(cur_crawl_list) >0:
    count += 1
    if count %1000 == 0:
        print(count)
    if count >1000000:
        break
    x = cur_crawl_list.popleft()
    if x in url_crawled:
        continue
    htmlcontent_dict = json.loads(getHtml(x))
    url_crawled.add(x)
    if 'continue' in htmlcontent_dict:
        if '&cmcontinue=' in x:
            nextpageurl = x.split('&cmcontinue=')[0]+'&cmcontinue='+htmlcontent_dict['continue']['cmcontinue']
        else:
            nextpageurl = x+'&cmcontinue='+htmlcontent_dict['continue']['cmcontinue']
        if nextpageurl not in url_crawled:
            cur_crawl_list.append(nextpageurl)
    if 'query' in htmlcontent_dict:
        if 'categorymembers' in htmlcontent_dict['query']:
            for item in htmlcontent_dict['query']['categorymembers']:
                if 'Category:' != item['title'][:9]:
                    page_obtained.add('_'.join(item['title'].split(' '))+' '+str(item['pageid']))


with open('./page_obtained.txt','w',encoding='utf8') as f:
    for x in page_obtained:
        f.write(x+'\n')

print('END')