package trainset;
//This program is to generate the training text which is stemmed from table article.
//input is trainingset_title.
//and we can define the sql statement to output the corresponding text.
import java.io.UnsupportedEncodingException;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import Operaino_Sectiontitle.Removehtmlcode;
import operation_Firstsen.Lvgtransform;
import feature.Searcher;
import feature.Word2Vec;
import operation_Firstsen.FirstsenReplace;
import operation_Firstsen.RemoveLword;

public class Generate_Text { //1 place need revise
	public static boolean is_disambig(String content){
		//rule: {{sia}} dis}}\n  disambiguation}}\n   disambig}}\n
		content = content.toLowerCase();
		char[] ctext = content.toCharArray();
		int len = ctext.length;
		int k = 0;
		for(int i =0;i<len-7;i++){
			if(ctext[i] == '\n'&&ctext[i+1]=='{'&&ctext[i+2]=='{'){
				i=i+2;
				k=i;
				if(ctext[i+1]=='s'&&ctext[i+2]=='i'&&ctext[i+3]=='a'){
					if(i+5<len&&ctext[i+4]=='}'&&ctext[i+5]=='}')return true;
				}
				while(i<len-5){
					i++;
					if(ctext[i]=='d'&&ctext[i+1]=='i'&&ctext[i+2]=='s'){
						i=i+3;
						if(i+1<len&&ctext[i]=='}'&&ctext[i+1]=='}')return true;
						if(i+2<len&&ctext[i]=='a'&&ctext[i+1]=='m'&&ctext[i+2]=='b'){
			
							if(i+6<len&&ctext[i+4]=='g'){
								if(ctext[i+5]=='}'&&ctext[i+6]=='}')
								return true;
								if(ctext[i+5]=='|'){
									int j = i+5;
									while(j<len){
										j++;
										if(ctext[j]=='}'&&ctext[j+1]=='}')return true;
									    if(ctext[j]=='\n')break;
									}
								}
							}
							
						}//disambiguation}}
						if(i+12<len&&ctext[i+4]=='g'&&ctext[i+6]=='a'&&ctext[i+8]=='i'&&ctext[i+10]=='n'&&ctext[i+11]=='}'){
							if(ctext[i+12]=='}'){
								return true;
							}
						}
						
					}
					if(ctext[i]=='|'){
						//{{disambiguation|...
						if(k+15==i&&ctext[k+1]=='d'&&ctext[k+3]=='s'&&ctext[k+6]=='b'&&ctext[i-1]=='n')return true;
						if(k+6==i&&ctext[k+1]=='h'&&ctext[k+2]=='n'&&ctext[k+3]=='d'&&ctext[k+5]=='s')return true;
					}
					if(ctext[i]=='{'||ctext[i]=='}'||ctext[i]=='\n'){
						break;
					}	
				}
			}
		}
		return false;
	}
    
    public static boolean is_referto(String content){
		//rule: short text and contain 'may refer to'
        //wiktionary re
        //surname include:
		content = content.toLowerCase();
		char[] ctext = content.toCharArray();
		int len = ctext.length;
		int k = 0;
		for(int i =0;i<len-12;i++){
			if(ctext[i] == 'm'&&ctext[i+1]=='a'&&ctext[i+2]=='y'&&ctext[i+3] == ' '&&ctext[i+4]=='r'&&ctext[i+5]=='e'&&ctext[i+6] == 'f'&&ctext[i+7]=='e'&&ctext[i+8]=='r'&&ctext[i+9] == ' '&&ctext[i+10]=='t'&&ctext[i+11]=='o'){
				if(len<500)return true;}
            if(ctext[i] == 'c'&&ctext[i+1]=='a'&&ctext[i+2]=='n'&&ctext[i+3] == ' '&&ctext[i+4]=='r'&&ctext[i+5]=='e'&&ctext[i+6] == 'f'&&ctext[i+7]=='e'&&ctext[i+8]=='r'&&ctext[i+9] == ' '&&ctext[i+10]=='t'&&ctext[i+11]=='o'){
				if(len<500)return true;}
            if(ctext[i] == 'w'&&ctext[i+1]=='i'&&ctext[i+2]=='k'&&ctext[i+3] == 't'&&ctext[i+4]=='i'&&ctext[i+5]=='o'&&ctext[i+6] == 'n'&&ctext[i+7]=='a'&&ctext[i+8]=='r'&&ctext[i+9] == 'y'&&ctext[i+10]==' '&&ctext[i+11]=='r'&&ctext[i+12]=='e'){
				if(len<500)return true;}
            if(ctext[i] == 's'&&ctext[i+1]=='u'&&ctext[i+2]=='r'&&ctext[i+3] == 'n'&&ctext[i+4]=='a'&&ctext[i+5]=='m'&&ctext[i+6] == 'e'&&ctext[i+7]==' '&&ctext[i+8]=='i'&&ctext[i+9] == 'n'&&ctext[i+10]=='c'&&ctext[i+11]=='l'&&ctext[i+12]=='u'){
				if(len<500)return true;}
        }
        return false;
	}
	public static String getStemmer(String text){
	   	Stemmer s = new Stemmer();
	   	String[] a = text.split(" ");
	   	StringBuilder builder = new StringBuilder();
	   	for(String str:a)builder.append(s.stem(str)+" ");
	   	return (builder.toString());
	   }
	public static String getStemmer_MT2char(String text){
	   	Stemmer s = new Stemmer();
	   	String[] a = text.split(" ");
	   	StringBuilder builder = new StringBuilder();
	   	for(String str:a){
	   		String temp = s.stem(str);
	   		if(temp.length()>2)
	   builder.append(s.stem(str)+" ");}
	   	return (builder.toString());
	   }
	String listTostring(List<String> a) {
		if (a == null)
			return null;
		if (a.size() == 0)
			return null;
		StringBuilder str = new StringBuilder();
		for (String b : a) {
			// a b -> a_b
			b = b.replaceAll("\\\\", "\\\\\\\\");// 
			b = b.replaceAll("\"", "\\\\\"");
			b = b.replaceAll("\\s", "_");
			str.append("\"" + b + "\"" + ",");
		}
		return str.substring(0, str.length() - 1);
	}
	final String url = "jdbc:mysql://127.0.0.1:3308/wiki?useUnicode=true&characterEncoding=utf-8&useSSL=false";
	final String name = "com.mysql.jdbc.Driver";
	final String user = "root";
	final String password = "V20erita_20s";
	public Generate_Text(){}
	
	void Export_All_Stemming_Articles(String outputpath,String titlepath){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		try (Connection conn = DriverManager.getConnection(url, user, password);
			PrintWriter allarticles = new PrintWriter(new OutputStreamWriter(new FileOutputStream(outputpath),"UTF-8"));
            PrintWriter allarticles_id = new PrintWriter(new OutputStreamWriter(new FileOutputStream(titlepath),"UTF-8"));) {
			int count = 0;
				Statement ps1 = conn.createStatement(java.sql.ResultSet.TYPE_FORWARD_ONLY,java.sql.ResultSet.CONCUR_READ_ONLY);
				ps1.setFetchSize(Integer.MIN_VALUE);
				ResultSet rs = ps1.executeQuery("select page_title,old_id,old_text from article;");
			while (rs.next()) {
				//try {
				//if(count<2944786) {count++;continue;}
				//System.out.println(rs.getString(1)+"\t"+rs.getString(2));
                //if(count<5606000){count++;continue;}
                //if(count>5606000){System.out.println(rs.getString(1)+"\t"+rs.getString(2));}
				WikiText doc = new WikiText(rs.getString(3));
				//System.out.println(rs.getString(1)+"\t"+rs.getString(2));
				String temp = getStemmer(doc.getcontent_p());
				//String temp = getStemmer_MT2char(doc.getcontent_p());
				allarticles_id.write(rs.getString(1)+"\t"+rs.getString(2)+"\n");
				allarticles.write(temp+"\n");
				//}catch(Exception e) {
				//}
				count++;
				//System.out.println(count);
				if(count%1000==0)System.out.println(count);
                
				
			}
			rs.close();
		}catch (IOException e) {
			System.err.println(e.getMessage());
			e.printStackTrace();
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			e.printStackTrace();
			System.exit(1);
		} catch (WikiException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void Generate_alltext_byID(String basepath,String inputpath_txt){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
		try (Connection conn = DriverManager.getConnection(url, user, password);
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath_txt),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"content.txt"),"UTF-8"));
				PrintWriter category = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"category.txt"),"UTF-8"));
				PrintWriter infobox = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"infobox.txt"),"UTF-8"));
				PrintWriter subtitle = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"subtitle.txt"),"UTF-8"));
				PrintWriter section1title = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"section1title.txt"),"UTF-8"));
				PrintWriter firstsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstsentence.txt"),"UTF-8"));
				PrintWriter firstpara = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstpara.txt"),"UTF-8"));
				
				PrintWriter redirect = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"redirect.txt"),"UTF-8"));
				PrintWriter disam = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"disambiguation.txt"),"UTF-8"));
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"name.txt"),"UTF-8"));
			PrintWriter log = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Text1_log.txt"),"UTF-8"));
			) {
			LinkedList<String> articlename = new LinkedList<String>();
			//LinkedList<String> id = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				articlename.add(temp);
			}
			Statement ps1 = conn.createStatement();
			String cuiid=articlename.toString();
			ResultSet text = ps1
					.executeQuery("select page_title,old_text,page_latest from article where page_latest in ("
							+ cuiid.substring(1,cuiid.length()-1) + ")");
			int count=0;
			int i = 0;
			while(text.next()){
                String text_get2 = new String(text.getString(2).getBytes("iso-8859-1"),"UTF-8");
               String text_get1 = new String(text.getString(1).getBytes("iso-8859-1"),"UTF-8");	
				i++;
				if(is_disambig(text_get2.toLowerCase())){
					disam.write(text_get1+"\t"+text.getString(3)+"\n");
				}
				try{
				WikiText tmp = new WikiText(text_get2);
				
				
				if(tmp.isRedi){
					redirect.write(text_get1+"\n");
					continue;}
				String tempp = getStemmer(tmp.getcontent_p());
				
				dname.write(text_get1+"\t"+text.getString(3)+"\n");
				//System.out.println(text_get1);
				content.write(text_get1+"|"+tempp+"\n");
				subtitle.write(text_get1+"|"+getStemmer(tmp.getsubtitle_p())+"\n");
				section1title.write(Removehtmlcode.remove(tmp.getfirstSubtitle())+"\n");
				//section1title.write(tmp.getfirstSubtitle()+"\n");
				
				infobox.write(text_get1+"|"+tmp.getinfobox_p()+"\n");
				category.write(text_get1+"|"+getStemmer(tmp.getCategory_p())+"\n");
				firstsen.write(tmp.getFirstSen()+"\n");
				firstpara.write(tmp.getFirstPara()+"\n");
				if(count%1000==0)
					System.out.println(count);
				count++;
				}catch(WikiException e){
					log.write("......."+text.getString(1)+"......\n"+e.getMessage()+text.getString(1)+'\n');
				}catch(Exception e){
					log.write("......."+text.getString(1)+"......"+"\nmessage is  "+e.getMessage()+'\n'+text.getString(1)+'\n');
				}
			}
			System.out.println("count is"+count+"\n"+"actual count "+i);
			text.close();
			ps1.close();
			log.write("end!");
			
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
	void Generate_origincontent_byID(String basepath,String inputpath_txt){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
		try (Connection conn = DriverManager.getConnection(url, user, password);
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath_txt),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"content.txt"),"UTF-8"));
				PrintWriter firstsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstsentence.txt"),"UTF-8"));
				PrintWriter firstpara = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstpara.txt"),"UTF-8"));
				PrintWriter redirect = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"redirect.txt"),"UTF-8"));
				PrintWriter disam = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"disambiguation.txt"),"UTF-8"));
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"name.txt"),"UTF-8"));
			PrintWriter log = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Text1_log.txt"),"UTF-8"));
			) {
			LinkedList<String> articlename = new LinkedList<String>();
			//LinkedList<String> id = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				articlename.add(temp);
			}
			Statement ps1 = conn.createStatement();
			String cuiid=articlename.toString();
			ResultSet text = ps1
					.executeQuery("select page_title,old_text,page_latest from article where page_latest in ("
							+ cuiid.substring(1,cuiid.length()-1) + ")");
			int count=0;
			int i = 0;
			while(text.next()){	
				i++;
				if(is_disambig(text.getString(2).toLowerCase())){
					disam.write(text.getString(1)+"\t"+text.getString(3)+"\n");
				}
				try{
				WikiText tmp = new WikiText(text.getString(2));
				
				
				if(tmp.isRedi){
					redirect.write(text.getString(1)+"\n");
					continue;}
				
				dname.write(text.getString(1)+"\t"+text.getString(3)+"\n");
				content.write(tmp.getcontent().replace("\n", " ")+"\n");
				firstsen.write(tmp.getFirstSen()+"\n");
				firstpara.write(tmp.getFirstPara()+"\n");
				if(count%1000==0)
					System.out.println(count);
				count++;
				}catch(WikiException e){
					log.write("......."+text.getString(1)+"......\n"+e.getMessage()+text.getString(1)+'\n');
				}catch(Exception e){
					log.write("......."+text.getString(1)+"......"+"\nmessage is  "+e.getMessage()+'\n'+text.getString(1)+'\n');
				}
			}
			System.out.println("count is"+count+"\n"+"actual count "+i);
			text.close();
			ps1.close();
			log.write("end!");
			
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
	void Generate_related_wordvec_for_stemmingcontent(String stemmingcontentpath_txt,String outputpath_txt,String wordvec_path,String Idf_path){
		Word2Vec word2vec=new Word2Vec(wordvec_path,Idf_path);
		try (InputStreamReader isr = new InputStreamReader(new FileInputStream(stemmingcontentpath_txt),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter output = new PrintWriter(new OutputStreamWriter(new FileOutputStream(outputpath_txt),"UTF-8"));
						){
			String temp;
			while((temp=br.readLine())!=null){
				double[] result1 = word2vec.generate_vec_tfidf(temp);
				for(int i= 0;i<result1.length;i++){
					output.write(result1[i]+"\t");
				}
				output.write("\n");	
			}	
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	void Generate_related_wordvec_for_content(String contentpath_txt,String outputpath_txt,String wordvec_path,String Idf_path){
		Word2Vec word2vec=new Word2Vec(wordvec_path,Idf_path);
		try (InputStreamReader isr = new InputStreamReader(new FileInputStream(contentpath_txt),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter output = new PrintWriter(new OutputStreamWriter(new FileOutputStream(outputpath_txt),"UTF-8"));
						){
			String temp;
			while((temp=br.readLine())!=null){
			
				String[] items = temp.split("\\|");
				if(items.length==1) temp = " ";
				else temp=Generate_Text.getStemmer_MT2char(items[1]);
				double[] result1 = word2vec.generate_vec_tfidf(temp);
				for(int i= 0;i<result1.length;i++){
					output.write(result1[i]+"\t");
				}
				output.write("\n");	
			}	
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	void Generate_related_stemmingMT2_for_content(String contentpath_txt,String outputpath_txt){
		try (InputStreamReader isr = new InputStreamReader(new FileInputStream(contentpath_txt),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter output = new PrintWriter(new OutputStreamWriter(new FileOutputStream(outputpath_txt),"UTF-8"));
						){
			String temp;
			while((temp=br.readLine())!=null){
				String[] items = temp.split("\\|");
				output.write(Generate_Text.getStemmer_MT2char(items[1])+"\n");
		}	
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	void Generate_4text_w2v_byID(String basepath,String inputpath_txt,String wordvec_path,String Idf_path){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
		try (Connection conn = DriverManager.getConnection(url, user, password);
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath_txt),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"content.txt"),"UTF-8"));
				PrintWriter wordvec = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"wordvec.txt"),"UTF-8"));
				PrintWriter category = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"category.txt"),"UTF-8"));
				PrintWriter infobox = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"infobox.txt"),"UTF-8"));
				PrintWriter subtitle = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"subtitle.txt"),"UTF-8"));
				PrintWriter redirect = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"redirect.txt"),"UTF-8"));
				PrintWriter disam = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"disambiguation.txt"),"UTF-8"));
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"name.txt"),"UTF-8"));
			PrintWriter log = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Text1_log.txt"),"UTF-8"));
				) {
			LinkedList<String> articlename = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				articlename.add(temp);
			}
			Word2Vec word2vec=new Word2Vec(wordvec_path,Idf_path);
			Statement ps1 = conn.createStatement();
			String cuiid=articlename.toString();
			ResultSet text = ps1
					.executeQuery("select page_title,old_text,page_latest from article where page_latest in ("
							+ cuiid.substring(1,cuiid.length()-1) + ")");
			int count=0;
			while(text.next()){				
				if(is_disambig(text.getString(2).toLowerCase())){
					disam.write(text.getString(1)+"\t"+text.getString(3)+"\n");
				}
				try{
				WikiText tmp = new WikiText(text.getString(2));
				
				if(tmp.isRedi){
					redirect.write(text.getString(1)+"\n");
					continue;}
				String tempp = getStemmer(tmp.getcontent_p());
				double[] result1 = word2vec.generate_vec_tfidf(tempp);
				for(int i= 0;i<result1.length;i++){
					wordvec.write(result1[i]+"\t");
				}
				wordvec.write("\n");
				dname.write(text.getString(1)+"\t"+text.getString(3)+"\n");
				content.write(text.getString(1)+"|"+tempp+"\n");
				subtitle.write(text.getString(1)+"|"+getStemmer(tmp.getsubtitle_p())+"\n");
				infobox.write(text.getString(1)+"|"+tmp.getinfobox_p()+"\n");
				category.write(text.getString(1)+"|"+getStemmer(tmp.getCategory_p())+"\n");
				if(count%1000==0)System.out.println(count);
				count++;
				}catch(WikiException e){
					log.write("......."+text.getString(1)+"......\n"+e.getMessage()+text.getString(1)+'\n');
				}catch(Exception e){
					log.write("......."+text.getString(1)+"......"+"\nmessage is  "+e.getMessage()+'\n'+text.getString(1)+'\n');
				}
			}
			System.out.println("count is"+count);
			text.close();
			ps1.close();
			log.write("end!");
			
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
	
	public void Generate_id_disam_forinputtxt(String outputpath,String inputpath){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		HashMap<String,String> titletoid = new HashMap<String,String>();
		//String basepath = "C:\\Users\\team\\Desktop\\yls_WORK\\trainingset\\data_stemmer\\";
		try (Connection conn = DriverManager.getConnection(url, user, password);
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(outputpath),"UTF-8"));
				) {
			LinkedList<String> articlename = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				String[] item = temp.split("[|]");
				articlename.add(item[0]);
				titletoid.put(item[0], item[1]);
			}
			//System.out.print(articlename.toString());
			Statement ps1 = conn.createStatement();
			ResultSet text = ps1
					.executeQuery("select page_title,page_latest,old_text from article where page_title in ("
							+ listTostring(articlename) + ")");
			int count=0;
			while(text.next()){	
				//String title = titleid.get(text.getInt(2));
				dname.write(text.getString(1)+"\t"+text.getString(2)+"\t"+titletoid.get(text.getString(1))+"\t");
				if(is_disambig(text.getString(3)))dname.write("isdis\n");
				else dname.write("notdis\n");
				if(count%1000==0)System.out.println(count);
				count++;
			}
			System.out.println("count is"+count);
			text.close();
			ps1.close();
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
	
	void Generate_include_redirect_id_forinputtxt(String basepath,String inputpath){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
		//String basepath = "C:\\Users\\team\\Desktop\\yls_WORK\\trainingset\\data_stemmer\\";
		try (Connection conn = DriverManager.getConnection(url, user, password);
				//InputStreamReader isr = new InputStreamReader(new FileInputStream(basepath+"trainingset_title.txt"),"UTF-8");
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath),"UTF-8"));
				//	PrintWriter test = new PrintWriter(basepath+"trainingset_java_svm_test.txt");
				) {
			LinkedList<String> articlename = new LinkedList<String>();
			//LinkedList<String> id = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				articlename.add(temp);
			}
			Statement ps1 = conn.createStatement();
			ResultSet text = ps1
					.executeQuery("select page_title,page_latest,page_is_redirect from page where page_title in ("
							+ listTostring(articlename) + ") and page_namespace = 0");
			int count=0;
			while(text.next()){	
				//String title = titleid.get(text.getInt(2));
				dname.write(text.getString(1)+"\t"+text.getString(2)+"\t"+text.getString(3)+"\n");
				if(count%1000==0)System.out.println(count);
				count++;
			}
			System.out.println("count is"+count);
			text.close();
			ps1.close();
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
	
	void Find_title_forinput_id(String basepath,String inputpath){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
		//String basepath = "C:\\Users\\team\\Desktop\\yls_WORK\\trainingset\\data_stemmer\\";
		try (Connection conn = DriverManager.getConnection(url, user, password);
				//InputStreamReader isr = new InputStreamReader(new FileInputStream(basepath+"trainingset_title.txt"),"UTF-8");
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"title_id.txt"),"UTF-8"));
				//	PrintWriter test = new PrintWriter(basepath+"trainingset_java_svm_test.txt");
				) {
			LinkedList<String> articlename = new LinkedList<String>();
			//LinkedList<String> id = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				articlename.add(temp);
			}
			Statement ps1 = conn.createStatement();
			ResultSet text = ps1
					.executeQuery("select page_latest,page_title from page where page_latest in ("
							+ listTostring(articlename) + ")");
			int count=0;
			
			while(text.next()){	
				//String title = titleid.get(text.getInt(2));
				dname.write(text.getInt(1)+"\t"+text.getString(2)+"\n");
				if(count%1000==0)System.out.println(count);
				count++;
			}
			System.out.println("count is"+count);
			text.close();
			ps1.close();
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
	
    void test_forinput_id(String basepath,String inputpath){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
		//String basepath = "C:\\Users\\team\\Desktop\\yls_WORK\\trainingset\\data_stemmer\\";
		try (Connection conn = DriverManager.getConnection(url, user, password);
				//InputStreamReader isr = new InputStreamReader(new FileInputStream(basepath+"trainingset_title.txt"),"UTF-8");
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"log.txt"),"UTF-8"));
				//	PrintWriter test = new PrintWriter(basepath+"trainingset_java_svm_test.txt");
				) {
			LinkedList<String> articlename = new LinkedList<String>();
			//LinkedList<String> id = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				articlename.add(temp);
			}
			Statement ps1 = conn.createStatement();
			ResultSet text = ps1
					.executeQuery("select page_latest,page_title,old_text from article where page_latest in ("+ listTostring(articlename) + ")");
			int count=0;
			
			while(text.next()){	
				//String title = titleid.get(text.getInt(2));
                if(text.getString(3).length() <500){
				//dname.write(text.getInt(1)+"\t"+text.getString(2)+"\t"+text.getString(3)+"\n");
                    if(!Generate_Text.is_referto(text.getString(3))){dname.write(text.getInt(1)+"\t"+text.getString(2)+"\t"+text.getString(3)+"\n");}
                }
				if(count%1000==0)System.out.println(count);
				count++;
			}
			System.out.println("count is"+count);
			text.close();
			ps1.close();
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
    
	//the following statement will generate word2vec text
	public void Generate_text_fsen_w2v_byID(String basepath,String inputpath_txt,String wordvec_path,String idf_path){
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		try (Connection conn = DriverManager.getConnection(url, user, password);
				//InputStreamReader isr = new InputStreamReader(new FileInputStream(basepath+"trainingset_title.txt"),"UTF-8");
				InputStreamReader isr = new InputStreamReader(new FileInputStream(inputpath_txt),"UTF-8");
				BufferedReader br = new BufferedReader(isr);
				PrintWriter content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"content.txt"),"UTF-8"));
				PrintWriter wordvec = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"wordvec.txt"),"UTF-8"));
				PrintWriter category = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"category.txt"),"UTF-8"));
				PrintWriter infobox = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"infobox.txt"),"UTF-8"));
				PrintWriter subtitle = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"subtitle.txt"),"UTF-8"));
				PrintWriter sen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstsen.txt"),"UTF-8"));
				PrintWriter firstvar = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstsen_variables.txt"),"UTF-8"));
				PrintWriter redirect = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"redirect.txt"),"UTF-8"));
				PrintWriter disam = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"disambiguation.txt"),"UTF-8"));
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"titlename.txt"),"UTF-8"));
				PrintWriter log = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Text1_log.txt"),"UTF-8"));
				) {
			LinkedList<String> articlename = new LinkedList<String>();
			String temp;
			while((temp=br.readLine())!=null){
				articlename.add(temp);
			}
			Searcher searcher = new Searcher();
			Word2Vec word2vec=new Word2Vec(wordvec_path,idf_path);
			Statement ps1 = conn.createStatement();
			String cuiid=articlename.toString();
			ResultSet text = ps1
					.executeQuery("select page_title,old_text,page_latest from article where page_latest in ("
							+ cuiid.substring(1,cuiid.length()-1) + ")");
			int count=0;
			
			
			
			while(text.next()){	
String text_get1 = new String(text.getString(1).getBytes("iso-8859-1"),"UTF-8");
String text_get2 = new String(text.getString(2).getBytes("iso-8859-1"),"UTF-8");
				if(is_disambig(text_get2.toLowerCase())){
					disam.write(text_get1+"\t"+text.getString(3)+"\n");
				}
				try{
				WikiText tmp = new WikiText(text_get2);
					
				if(tmp.isRedi){
					redirect.write(text_get1+"\n");
					continue;}
				String tempp = getStemmer(tmp.getcontent_p());
				double[] result1 = word2vec.generate_vec_tfidf(tempp);
				for(int i= 0;i<result1.length;i++){
					wordvec.write(result1[i]+"\t");
				}
				wordvec.write("\n");
				double[] fir = searcher.search(tmp.getFirstSen(), tmp.getcontent_p());
				for(int i= 0;i<fir.length;i++){
                firstvar.write(fir[i]+"\t");
				}
				firstvar.write("\n");
				
				dname.write(text_get1+"\t"+text.getString(3)+"\n");
				content.write(text_get1+"|"+tempp+"\n");
				subtitle.write(text_get1+"|"+getStemmer(tmp.getsubtitle_p())+"\n");
				infobox.write(text_get1+"|"+tmp.getinfobox_p()+"\n");
				category.write(text_get1+"|"+getStemmer(tmp.getCategory_p())+"\n");
				sen.write(tmp.getFirstSen()+"\n");
				if(count%1000==0)
					System.out.println(count);
				count++;
				}catch(WikiException e){
					e.getStackTrace();
					log.write("......."+text.getString(1)+"......\n"+e.getMessage()+text.getString(1)+'\n');
				}catch(Exception e){
					e.getStackTrace();
					log.write("......."+text.getString(1)+"......"+"\nmessage is  "+e.getMessage()+'\n'+text.getString(1)+'\n');
				}
			}
		
			
			System.out.println("count is"+count);
			text.close();
			ps1.close();
			log.write("end!");
			
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	
	}
	
	
	void Generate_All_text_forsql(String basepath, String sql){//write all file
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		try (Connection conn = DriverManager.getConnection(url, user, password);
				PrintWriter content = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"content.txt"),"UTF-8"));
				PrintWriter category = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"category.txt"),"UTF-8"));
				PrintWriter infobox = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"infobox.txt"),"UTF-8"));
				PrintWriter subtitle = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"subtitle.txt"),"UTF-8"));
				PrintWriter sen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstsen.txt"),"UTF-8"));
				PrintWriter redirect = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"redirect.txt"),"UTF-8"));
				PrintWriter disam = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"disambiguation.txt"),"UTF-8"));
				PrintWriter firstvar = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"firstsen_variables.txt"),"UTF-8"));
				PrintWriter dname = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"name.txt"),"UTF-8"));
			PrintWriter log = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Text1_log.txt"),"UTF-8"));
				PrintWriter newvar = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"var_firsen.txt"),"UTF-8"));
				PrintWriter wordvec = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"wordvec.txt"),"UTF-8"));
				) {
			Word2Vec word2vec = new Word2Vec();
			Statement ps1 = conn.createStatement();
			ResultSet text = ps1
					.executeQuery(sql);
			Searcher searcher = new Searcher();
			int count=0;
			while(text.next()){	
				if(is_disambig(text.getString(2).toLowerCase())){
					disam.write(text.getString(1)+"\n");
				}
				try{
				WikiText tmp = new WikiText(text.getString(2));
				if(tmp.isRedi){
					redirect.write(text.getString(1)+"\n");
					continue;}
				String tempp = getStemmer(tmp.getcontent_p());
				content.write(text.getString(1)+"|"+tempp+"\n");
				subtitle.write(text.getString(1)+"|"+getStemmer(tmp.getsubtitle_p())+"\n");
				infobox.write(text.getString(1)+"|"+tmp.getinfobox_p()+"\n");
				category.write(text.getString(1)+"|"+getStemmer(tmp.getCategory_p())+"\n");
				sen.write(tmp.getFirstSen()+"\n");
				double result1[] = word2vec.generate_vec_tfidf(tempp);
				for(int i= 0;i<result1.length;i++){
					wordvec.write(result1[i]+"\t");
				}
				wordvec.write("\n");
				if(count%1000==0)System.out.println(count);
				double[] fir = searcher.search(tmp.getFirstSen(), tmp.getcontent_p());
				for(int i= 0;i<fir.length;i++){
                firstvar.write(fir[i]+"\t");
				}
				firstvar.write("\n");
				
				count++;
				}catch(WikiException e){
					log.write("......."+text.getString(1)+"......\n"+e.getMessage()+text.getString(1)+'\n');
				}catch(Exception e){
					log.write("......."+text.getString(1)+"......"+"\nmessage is  "+e.getMessage()+'\n'+text.getString(1)+'\n');
				}
			}
			System.out.println("count is"+count);
			text.close();
			ps1.close();
			log.write("end!");
			
		}catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
		
	}
	public static void main(String[] args){
		String basepath="/media/sda3/veritas/Wikipedia/new_experiment/EXP2/";//need revise
		Generate_Text text1 = new Generate_Text();
		System.out.println("print");

 //1, generate text for w2v.       //text1.Export_All_Stemming_Articles(basepath+"../WIKIPEDIA_DATA/ALLSTEMMINGCONTENT_charMT2.txt",basepath+"../WIKIPEDIA_DATA/ALLSTEMMINGCONTENT_charMT2_ID.txt");
     //2, generate trainset text for two classifications.
        /*
text1.Generate_text_fsen_w2v_byID(basepath+"First_Train/data/", basepath+"wikimatchumls/TRAINSET1st_ID.txt", basepath+"../WORDVEC_TABLE/WORDVECforBINARYCLASSIFY.txt", basepath+"../WORDVEC_TABLE/IDFforBINARYCLASSIFY.txt");
        text1.Generate_alltext_byID(basepath+"Second_Train/data/", basepath+"wikimatchumls/TRAINSET2nd_ID.txt");
        */
        
        /*
        //3, generate trainset for the seconde classification and the text of the spider result
        String spiderresultpath = basepath+"First_Train/spider_result/imp_article_id.txt";
		String write2ndidpath = basepath+"Second_Train/spiderresult/IMPATC1st_ID.txt";
		try (InputStreamReader readid = new InputStreamReader(new FileInputStream(spiderresultpath),"UTF-8");
				BufferedReader read = new BufferedReader(readid);
				PrintWriter writeid = new PrintWriter(new OutputStreamWriter(new FileOutputStream(write2ndidpath),"UTF-8"));
				) {
			String temp;
			while((temp = read.readLine())!= null){
				String[] item = temp.split("\t");
				writeid.write(item[1]+"\n");
			}
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		text1.Generate_alltext_byID(basepath+"Second_Train/spiderresult/", basepath+"Second_Train/spiderresult/IMPATC1st_ID.txt");
        */
        
        
        /*
        //3, generate trainset for the seconde classification and the text of the spider result
        String spiderresultpath = basepath+"First_Train/spider_result/imp_article_id.txt";
		String write2ndidpath = basepath+"Second_Train/spiderresult/IMPATC1st_ID.txt";
		try (InputStreamReader readid = new InputStreamReader(new FileInputStream(spiderresultpath),"UTF-8");
				BufferedReader read = new BufferedReader(readid);
				PrintWriter writeid = new PrintWriter(new OutputStreamWriter(new FileOutputStream(write2ndidpath),"UTF-8"));
				) {
			String temp;
			while((temp = read.readLine())!= null){
				String[] item = temp.split("\t");
				writeid.write(item[1]+"\n");
			}
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		text1.Generate_alltext_byID(basepath+"Second_Train/spiderresult/", basepath+"Second_Train/spiderresult/IMPATC1st_ID.txt");
		Lvgtransform lvg = new Lvgtransform();
		try(
		InputStreamReader isr2 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/data/firstsentence.txt"),"UTF-8");
		BufferedReader firsen = new BufferedReader(isr2);
		PrintWriter lvgfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/data/LVGfirstsentence.txt"),"UTF-8"));
				){
		String temp;
		int count =0;
		while((temp=firsen.readLine())!=null){
			String transentence = FirstsenReplace.regrex_bracket_space(temp).replaceAll("[^\\w0-9]"," ").replaceAll("\\s+", " ");
		lvgfirsen.write(lvg.mutate_sen(transentence)+"\n");
		count++;
		if(count%1000==0)System.out.println(count);
		}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		try(
				InputStreamReader isr2 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/data/firstpara.txt"),"UTF-8");
				BufferedReader firsen = new BufferedReader(isr2);
				PrintWriter lvgfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/data/LVGfirstpara.txt"),"UTF-8"));
						){
				String temp;
				int count =0;
				while((temp=firsen.readLine())!=null){
					String transentence = FirstsenReplace.regrex_bracket_space(temp).replaceAll("[^\\w0-9]"," ").replaceAll("\\s+", " ");
				lvgfirsen.write(lvg.mutate_sen(transentence)+"\n");
				count++;
				if(count%1000==0)System.out.println(count);
				}
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
		try(
				InputStreamReader isr2 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/spiderresult/firstsentence.txt"),"UTF-8");
				BufferedReader firsen = new BufferedReader(isr2);
				InputStreamReader isr3 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/data/LVGfirstsentence.txt"),"UTF-8");
				BufferedReader trainfirsen = new BufferedReader(isr3);
				PrintWriter allfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/data/allfirstsentence.txt"),"UTF-8"));
				PrintWriter lvgfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/spiderresult/LVGfirstsentence.txt"),"UTF-8"));
						){
				String temp;
				int count =0;
				while((temp=trainfirsen.readLine())!=null){
					allfirsen.write(temp+"\n");
				}
				String lvgsen;
				while((temp=firsen.readLine())!=null){
					String transentence = FirstsenReplace.regrex_bracket_space(temp).replaceAll("[^\\w0-9]"," ").replaceAll("\\s+", " ");
				lvgsen = lvg.mutate_sen(transentence);
				lvgfirsen.write(lvgsen+"\n");
				allfirsen.write(lvgsen+"\n");
				count++;
				if(count%1000==0)System.out.println(count);
				}
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
		try(
				InputStreamReader isr2 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/spiderresult/firstpara.txt"),"UTF-8");
				BufferedReader firsen = new BufferedReader(isr2);
				InputStreamReader isr3 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/data/LVGfirstpara.txt"),"UTF-8");
				BufferedReader trainfirsen = new BufferedReader(isr3);
				PrintWriter allfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/data/allfirstpara.txt"),"UTF-8"));
				PrintWriter lvgfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/spiderresult/LVGfirstpara.txt"),"UTF-8"));
						){
				String temp;
				int count =0;
				while((temp=trainfirsen.readLine())!=null){
					allfirsen.write(temp+"\n");
				}
				String lvgsen;
				while((temp=firsen.readLine())!=null){
					String transentence = FirstsenReplace.regrex_bracket_space(temp).replaceAll("[^\\w0-9]"," ").replaceAll("\\s+", " ");
				lvgsen = lvg.mutate_sen(transentence);
				lvgfirsen.write(lvgsen+"\n");
				allfirsen.write(lvgsen+"\n");
				count++;
				if(count%1000==0)System.out.println(count);
				}
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
		try(
				InputStreamReader isr2 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/data/section1title.txt"),"UTF-8");
				BufferedReader firsen = new BufferedReader(isr2);
				PrintWriter lvgfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/data/LVGsection1title.txt"),"UTF-8"));
						){
				String temp;
				int count =0;
				while((temp=firsen.readLine())!=null){
					String transentence = temp.replaceAll("[^\\w0-9]"," ").replaceAll("\\s+", " ");
				lvgfirsen.write(lvg.mutate_sen(transentence)+"\n");
				count++;
				if(count%1000==0)System.out.println(count);
				}
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
		try(
				InputStreamReader isr2 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/spiderresult/section1title.txt"),"UTF-8");
				BufferedReader firsen = new BufferedReader(isr2);
				
				InputStreamReader isr3 = new InputStreamReader(new FileInputStream(basepath+"Second_Train/data/LVGsection1title.txt"),"UTF-8");
				BufferedReader trainfirsen = new BufferedReader(isr3);
				PrintWriter allfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/data/allsection1title.txt"),"UTF-8"));
				
				PrintWriter lvgfirsen = new PrintWriter(new OutputStreamWriter(new FileOutputStream(basepath+"Second_Train/spiderresult/LVGsection1title.txt"),"UTF-8"));
						){
				String temp;
				int count =0;
				while((temp=trainfirsen.readLine())!=null){
					allfirsen.write(temp+"\n");
				}
				String lvgsen;
				while((temp=firsen.readLine())!=null){
					String transentence = temp.replaceAll("[^\\w0-9]"," ").replaceAll("\\s+", " ");
				lvgsen = lvg.mutate_sen(transentence);
				lvgfirsen.write(lvgsen+"\n");
				allfirsen.write(lvgsen+"\n");
				count++;
				if(count%1000==0)System.out.println(count);
				}
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
		System.out.println("LVG operation ends");
        */
        
        /*
        //4, generate text for trainset and testset of the second classification
        RemoveLword rw = new RemoveLword(basepath+"Second_Train/data/wordcount_sen.txt",8);
		rw.removeLwordfortxt(basepath+"Second_Train/data/LVGfirstsentence.txt", basepath+"Second_Train/train/LVGfirstsentence_LT.txt");
		rw.removeLwordfortxt(basepath+"Second_Train/spiderresult/LVGfirstsentence.txt", basepath+"Second_Train/test/LVGfirstsentence_LT.txt");
		
		RemoveLword rw2 = new RemoveLword(basepath+"Second_Train/data/wordcount_para.txt",12);
		rw2.removeLwordfortxt(basepath+"Second_Train/data/LVGfirstpara.txt", basepath+"Second_Train/train/LVGfirstpara_LT.txt");
		rw2.removeLwordfortxt(basepath+"Second_Train/spiderresult/LVGfirstpara.txt", basepath+"Second_Train/test/LVGfirstpara_LT.txt");
		
		RemoveLword rw3 = new RemoveLword(basepath+"Second_Train/data/wordcount_cttl.txt",4);
		rw3.removeLwordfortxt(basepath+"Second_Train/data/LVGsection1title.txt", basepath+"Second_Train/train/LVGsection1title_LT.txt");
		rw3.removeLwordfortxt(basepath+"Second_Train/spiderresult/LVGsection1title.txt", basepath+"Second_Train/test/LVGsection1title_LT.txt");
        */
        
	}
}
