package trainset;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import Operaino_Sectiontitle.Removehtmlcode;

public class WikiText {

	private String firstSen;
	private String content;
	private String category;
	private String subtitle;
	private String section1title;
	private String infobox;
	private String firstpara;
	private String firstPart;
	public Boolean firstSen_empty;
	public Boolean infobox_empty;
	public Boolean isRedi;
	public Boolean isWikt=false;
	public Boolean firstPara_empty;
	public Boolean firstPart_empty;
	public Boolean subtitle_empty;
	public Boolean category_empty;

	public WikiText(String text) throws WikiException {
		char[] ctext = text.toCharArray();
		int len = ctext.length;
		try {
			char[] result = new char[len];
			int s = 0;
			int firstchar = 0;
			int paraendid = 0;
			int firstpart_endid = 0;
			firstSen_empty = true;
			infobox_empty = true;
			firstPara_empty = true;
			firstPart_empty = true;
			int kkk = 0;
			while(ctext[kkk]=='\n'||ctext[kkk]==' '||ctext[kkk]==0)kkk++;
			if (ctext[kkk] == '#' && (ctext[kkk+1] == 'R' || ctext[kkk+1] == 'r') && (ctext[kkk+2] == 'E' || ctext[kkk+2] == 'e'))
			{	isRedi = true;
			firstSen="";content="";category="";subtitle="";infobox="";firstpara="";
			firstPart="";section1title = "";
			subtitle_empty=false;
			category_empty=false;
			infobox_empty = false;
			firstPart_empty = false;
			return;
			}
			else
				isRedi = false;
			
			int k = 0;
			int stack = 0;
			StringBuilder title = new StringBuilder();
			StringBuilder title1 = new StringBuilder();
			StringBuilder title2 = new StringBuilder();
			StringBuilder title3 = new StringBuilder();
			StringBuilder title4 = new StringBuilder();
			StringBuilder infobox0 = new StringBuilder();
			StringBuilder category0 = new StringBuilder();

			int z = 0;
			for (int i = 0; i < len; i++) {

				if (ctext[i] == '<') {
					if ((i+3)<len && ctext[i + 1] == '!' && ctext[i + 2] == '-' && ctext[i + 3] == '-') {
						i = i + 3;
						while (i < len) {
							i++;
							if ((i+2)<len && ctext[i] == '-' && ctext[i + 1] == '-' && ctext[i + 2] == '>') {
								i = i + 2;
								break;
							} else if ((i+1)<len && ctext[i] == '\n' && ctext[i + 1] == '\n') {
								i++;
								break;
							}
						}
					} else if ((i+4)<len && ctext[i + 1] == 'r' && ctext[i + 2] == 'e' && ctext[i + 3] == 'f' && ctext[i + 4] != 'e') {
						i = i + 3;
						while (i < len) {
							i++;
							if (i >= len) {
								break;
								}
							if (ctext[i] == '/') {
								i++;
								if (ctext[i] == '>')
									{
									if(s>0&&result[s-1]!=' ')
									{result[s]=' ';
									s++;}//revised replace <ref>..<\> with ' '
									break;}
								if (i+3<len && (ctext[i] == 'r'|| ctext[i] == 'R') && ctext[i + 1] == 'e' && (ctext[i + 2] == 'f' || ctext[i + 2] == 'F') && ctext[i + 3] == '>') {
									i = i + 3;
									if(s>0&&result[s-1]!=' ')
									{result[s]=' ';
									s++;}//revised replace <ref>..<\> with ' '
									break;
								}
							}else if (i+1<len &&ctext[i]=='\n'&&ctext[i+1]=='\n')break;//濮濄倕顦╂稉鍝勵槱閻炲棜顕氬▓绁巋row閻拷
						}
					} 
					else if(i+3<len && ctext[i + 1] == 'd' && ctext[i + 2] == 'i' && ctext[i + 3] == 'v'){//revised 16/8/2017
						i = i + 3;
						int kk = 1;
						while (i < len) {
							i++;
							if(i+3<len && ctext[i]=='<'&&ctext[i + 1] == 'd' && ctext[i + 2] == 'i' && ctext[i + 3] == 'v')kk++;
							if (i >= len) {
								break;
								}
							if (ctext[i] >= '/') {
								i++;
								if (i+1<len &&ctext[i] == 'd' && ctext[i + 1] == 'i'
										&& ctext[i + 2] == 'v'  && ctext[i + 3] == '>') {
									i = i + 3;
									kk--;
								}
							}
							if(kk==0){
								if(s>0&&result[s-1]!=' '){
								result[s]=' ';
								s++;}//revised replace <div>..<\div> with ' '
								break;}
							if (i+1<len &&ctext[i]=='\n'&&ctext[i+1]=='\n'){
								break;}
						}
					}//revised end
					else {
						k = i;
						while (i < k + 15) {// within 15 units.<>
							i++;
							if (ctext[i] == '<' || ctext[i] == '>') {
								break;
							}
						}
						if (ctext[i] == '<') {
							i--;
							continue;
						} else if (ctext[i] != '>') {
							i = k;
							continue;
						}
					}
					continue;
				}
				if (i+1<len && ctext[i] == '[' && ctext[i + 1] == '[') {
					if(s>1&&result[s-1]=='\n')
					{if(result[s-2]!=' ')
					{
					result[s-1]=' ';
					result[s]='\n';
					s++;//!!!
					}
					}
					z = i + 2;
					i = i + 1;
					stack = 2;
					while (stack != 0 && i < len - 1) {
						i++;
						if (ctext[i] == ':') {
							if (ctext[i - 1] == 'y' && ctext[i - 4] == 'g' && ctext[i - 8] == 'C'
									&& ctext[i - 9] == '[') {
								i = i - 11;
								while (i < len-1) {
									i++;
									
									if (ctext[i] == '['  && ctext[i + 1] == '[' && (i==0 || ctext[i - 1] == '\n')) {
										if (ctext[i + 2] == 'C' && ctext[i + 3] == 'a' && ctext[i + 6] == 'g') {
											i = i + 10;
											k = i + 1;
											
											while (i < len-1) {
												i++;
												if (ctext[i] == ']' || ctext[i] == '|') {
													char[] temp = new char[i - k];
													for (int j = 0; j < i - k; j++) {
														temp[j] = ctext[k + j];
													}
													String tmp = new String(temp);
													category0.append(tmp + '\t');
													break;
												}
											}
										}
									}
								}//wikt:
							} else if(ctext[i-1]=='t'&&ctext[i-2]=='k'&&ctext[i-3]=='i'){continue;}
							else{
								while (stack != 0) {
									i++;
									if(i>=len)break;
									if (ctext[i] == '\n' && ctext[i + 1] == '\n') {
										stack = 0;
									} else if (ctext[i] == '[')
										stack = stack + 1;
									else if (ctext[i] == ']')
										stack = stack - 1;
								}
							}
						} else if (ctext[i] == '|') {
							z = i + 1;
							while (i+1<len && stack != 0) {
								i++;
								if (ctext[i] == '\n' && ctext[i + 1] == '\n') {
									stack = 0;
								} else if (ctext[i] == '[')
									stack = stack + 1;
								else if (ctext[i] == ']')
									stack = stack - 1;
								else {
									result[s] = ctext[i];
									s++;
								}
							}
						} else if (ctext[i] == ']' && ctext[i + 1] == ']') {
							for (int j = 0; j < i - z; j++) {
								result[s] = ctext[z + j];
								s++;
							}
							i++;
							stack = 0;
						} else if (ctext[i] == '[') {
							if (ctext[i - 1] == '\\') {
								i = i + 1;
							} else {
								stack = stack + 1;
								while ((i+1)<len && stack != 0) {
									i++;
									if (ctext[i] == '\n' && ctext[i + 1] == '\n') {
										stack = 0;
									} else if (ctext[i] == '[')
										stack = stack + 1;
									else if (ctext[i] == ']')
										stack = stack - 1;
								}
							}
						} else if ((i+1)<len && ctext[i] == '\n' && ctext[i + 1] == '\n') {
							stack = 0;
						}
					}
					continue;
				}
				// [http
				if (ctext[i] == '[' && ctext[i + 1] == 'h' && ctext[i + 3] == 't' && ctext[i + 4] == 'p') {
					stack = 1;
					i = i + 4;
					//int kkkk = i;
					while (stack != 0 && i < len) {
						i++;
						if (i >= len) break;
						//	throw new WikiException("瀵倸鐖剁�涙ê婀猍http :\\" + ctext[kkkk + 7] + ctext[kkkk + 8]
							//		+ ctext[kkkk + 9] + ctext[kkkk + 10] + "\n");
						if (ctext[i] == '[' && ctext[i - 1] != '\\')
							stack++;
						else if (ctext[i] == ']' && ctext[i - 1] != '\\')
							stack--;
						else if (ctext[i] == '\n' && ctext[i + 1] == '\n')
							stack = 0;
					}
					continue;
				}
				if (ctext[i] == '{' && ctext[i + 1] == '{') {
					i = i + 1;// infobox
					if(i + 13 < len && ctext[i + 13] == '\n' && ctext[i + 11] == '}'
							&& ctext[i + 1] == 'w' &&ctext[i + 2] == 'i' && ctext[i + 10] == 'y'&&ctext[i+3]=='k'&& ctext[i + 4] == 't'&&ctext[i + 6] == 'o' && ctext[i + 8] == 'a'){
						isWikt=true;
					}
					// if(i+7>len)System.out.println(text);
					if (infobox_empty && i + 8 < len && ctext[i + 5] == 'b' && ctext[i + 6] == 'o'
							&& ctext[i + 7] == 'x' && ctext[i + 4] != ' ') {//drugbox chembox
						
						infobox_empty = false;
						stack = 2;
						i = i + 8;
						
						if (ctext[i - 5] == 'f') {// infobox
							
							k = i + 1;
							while (i < len) {
								i++;

								if (ctext[i] == '\n' || ctext[i] == '}' || ctext[i] == '|') {

									char[] temp = new char[i - k];
									for (int j = 0; j < i - k; j++) {
										temp[j] = ctext[k + j];
									}
									String tmp = new String(temp);
									infobox0.append(tmp + '\t');
									break;
								}
							}
							if (ctext[i] == '}') {
								i++;
								stack = 0;
								continue;
							}
							if (ctext[i] == '|' || ctext[i] == '\n') {
								i--;
							}
						}
						if (ctext[i] == '|' || ctext[i] == '\n') {
							i--;
						}
						while (stack != 0 && i < len) {
							i++;
							if (i >= len) {
								break;
								//throw new WikiException("瀵倸鐖剁�涙ê婀猧nfobox鐠囪褰囨潻鍥┾柤閿涙瓡nstack is "+stack+"\n閹碉拷鐠囩杯nfobox娑擄拷" + infobox0.toString() + "\n");
							}
							if ((ctext[i] == '\n' || (ctext[i] == '|' && ctext[i + 1] == '\n')) && stack == 2) {
								while (ctext[i + 1] == ' ') {
									i++;
								} // i 閸嬫粎鏆�閸︺劍娓堕崥搴濈娑擃亞鈹栭弽鍏煎灗'\n'閿涘奔绗呮稉锟芥稉顏冭礋|閵嗭拷 閹达拷 i 閸嬫粎鏆�閸︼拷 |娑撳绔存稉顏冭礋\n
								if (ctext[i] == '|' || ctext[i + 1] == '|') {
								
									i++;
									while (ctext[i + 1] == ' ') {
										i++;
									}
									if (ctext[i + 1] == '{' || ctext[i + 1] == '[') {continue;}
									k = i + 1;
									//System.out.println("stack is "+stack+"  "+ctext[k]+ctext[k+1]);
									while (stack != 0 && i < len) {
										i++;
										if (ctext[i] == ' ' || ctext[i] == '=') {
											char[] temp = new char[i - k];
											for (int j = 0; j < i - k; j++) {
												temp[j] = ctext[k + j];
											}
											String tmp = new String(temp);
											infobox0.append(tmp + '\t');
											break;

										} else if (ctext[i] == '{') {
											
											if (ctext[i + 1] == '<' && ctext[i - 1] == '>') {
												continue;
											}
											stack++;
										} else if (ctext[i] == '}'){stack--;}
					
									}
									
								} // {{\}}
							}else if(ctext[i]=='\n' && ctext[i+1]=='\n' && (stack % 2) ==1){
								stack = 0;}
							else if (ctext[i] == '{') {
							
								if (ctext[i + 1] == '<' && ctext[i - 1] == '>') {
									continue;
								}
								stack++;
							} else if (ctext[i] == '}'){stack--;
							}
							else if(stack!=2&&ctext[i]=='\n'&&ctext[i+1]=='|'){//stack=4閺冭绱�
								stack = 2;
								i--;
							}
							

						}
						continue;

					}//infobox 鐠囪褰囩紒鎾存将	娑撳娼版稉鐑橆劀鐢摜娈憑{}}
					stack = 2;
					while (stack != 0 && i < len) {
						i++;
						if (i == len)break;
							//throw new WikiException("瀵倸鐖剁�涙ê婀獅{閺冪姴顕惔鏃傛畱閸栧綊鍘n");
						if (ctext[i] == '{') {
							if (ctext[i + 1] == '<' && ctext[i - 1] == '>') {
								continue;
							}
							stack++;
						} else if (ctext[i] == '}') {
							stack = stack - 1;
						} 
						else if (ctext[i] == '\n' && ctext[i + 1] == '\n') {// 33
							i++;
							if (ctext[i + 1] == ' ')
								i++;
							if (ctext[i + 1] == '}')
								continue;
							stack = 0;
						}
					}
					continue;
				}

				if (ctext[i] == '{' && ctext[i + 1] == '|') {
					if (i <= 1 || ctext[i - 1] == '\n' || ctext[i - 2] == '\n') {

						while (i < len) {
							i++;
							if (i == len) {
								// error0.append("error: {|***
								// 濞屸剝婀侀幍鎯у煂\\n|}\n"+"\ntext is \n"+text+'\n');
								break;
								//throw new WikiException("瀵倸鐖剁�涙ê婀獅|*|}鐠囪褰�:\n {|*** 濞屸剝婀侀幍鎯у煂|}\n");
							}
							if (ctext[i] == '}' && ctext[i - 1] == '|') {// 閺堝娈ｉ幃锟�
																			// 娑斿澧犳禒锝囩垳鏉╂ê瀵橀崥锟�&&ctext[i-2]=='\n'
								i++;
								break;
							} else if (ctext[i] == '\n' && ctext[i + 1] == '\n' && ctext[i + 2] != '<') {
								break;
							}
						}
						continue;
					}
				}
				if (i == 0) {
					if ((ctext[i] >= 'A' && ctext[i] <= 'Z') || (ctext[i] >= 'a' && ctext[i] <= 'z')
							|| ctext[i] == '\'') {
						firstchar = 0;
						firstSen_empty = false;
					}
				}
				if (ctext[i] == '\n' && firstSen_empty) {
					if (i == len - 1) {
						break;//濮濄倕顦╂稉鍝勵槱閻炲敆hrow
						//throw new WikiException("閺傚洦婀伴悧瑙勭暕閿涘牓娼鍌氱埗閿涳拷:濮濄倖妞傞張锟介崥搴濈娑擃亜鐡х粭锔胯礋閹广垼顢戠粭锔跨瑬缁楊兛绔撮崣銉よ礋缁岀n");
					}
					if (ctext[i + 1] >= 'a' && ctext[i + 1] <= 'z' || ctext[i + 1] >= 'A' && ctext[i + 1] <= 'Z'
							|| ctext[i + 1] == '\'' ||ctext[i+1] == '"') {
						firstchar = s;
						firstSen_empty = false;

					}

				}
				// &nbsp;
				if (ctext[i] == '&' && ctext[i + 1] == 'n' && ctext[i + 2] == 'b' && ctext[i + 5] == ';') {
					if(s>0&&result[s-1]!=' ')
					{result[s] = ' ';
					s++;}
					i = i + 5;
					continue;
				}

				

				if (ctext[i] == '=' && ctext[i + 1] == '=') {
					if (ctext[i + 2] != '=') {
						if (ctext[i + 2] == ' ')
							i++;
						if (ctext[i + 2] == 'S' && ctext[i + 3] == 'e' && ctext[i + 4] == 'e' && ctext[i + 6] == 'a'
								&& ctext[i + 8] == 's') {
							i = i + 10;
							while (i < len) {
								i++;
								if (i > len - 2)
									break;
								if (ctext[i] == '[' && ctext[i - 1] == '\n' && ctext[i + 1] == '[') {
									if ((i+6)<len && ctext[i + 2] == 'C' && ctext[i + 3] == 'a' && ctext[i + 6] == 'g') {
										i = i + 10;
										k = i + 1;
										while (i < len) {
											i++;
											if (i == len) {
												//break;
												break;//濮濄倕顦╂稉鍝勵槱閻炲敆hrow
												//throw new WikiException("0瀵倸鐖剁�涙ê婀猍[category鐠囪褰囬敍姝昻 濞屸剝婀佺�电懓绨查惃鍒擼閸栧綊鍘n");
											}
											if (ctext[i] == ']' || ctext[i] == '|') {
												char[] temp = new char[i - k];
												for (int j = 0; j < i - k; j++) {
													temp[j] = ctext[k + j];
												}
												String tmp = new String(temp);
												category0.append(tmp + '\t');
												break;
											}
										}
									}
								}
							}
							break;
						} else if (ctext[i + 2] == 'R' && ctext[i + 3] == 'e' && ctext[i + 4] == 'f'
								&& ctext[i + 8] == 'n') {
							i = i + 10;
							while (i < len) {
								i++;
								if (i > len - 3)
									break;
								if (ctext[i] == '[' && ctext[i - 1] == '\n' && ctext[i + 1] == '[') {
									if (ctext[i + 2] == 'C' && ctext[i + 3] == 'a' && ctext[i + 6] == 'g') {
										i = i + 10;
										k = i + 1;
										while (i < len) {
											i++;
											if (i == len) {
												break;//濮濄倕顦╂稉鍝勵槱閻炲敆hrow
												//throw new WikiException("1瀵倸鐖剁�涙ê婀猍[category鐠囪褰囬敍姝昻 濞屸剝婀佺�电懓绨查惃鍒擼閸栧綊鍘n");
											}
											if (ctext[i] == ']' || ctext[i] == '|') {
												char[] temp = new char[i - k];
												for (int j = 0; j < i - k; j++) {
													temp[j] = ctext[k + j];
												}
												String tmp = new String(temp);
												category0.append(tmp + '\t');
												break;
											}
										}
									}
								}
							}
							break;
						} else {
							i = i + 1;
							k = i + 1;
							if(firstPart_empty){//add it 2018.3.30
									firstPart_empty = false;
									firstpart_endid = s;
							}
							while (i < len) {
								i++;
								if (i == len) {
									break;
									//throw new WikiException("瀵倸鐖剁�涙ê婀猻ubtitle鐠囪褰囬張澶愭６妫版﹫绱癨n濞屸剝婀佺�电懓绨查惃锟�==閸栧綊鍘ら幋鏍ㄥ床鐞涘苯灏柊锟�");
								}
								if ((ctext[i] == '=' && ctext[i + 1] == '=') || ctext[i] == '\n') {
									
									if(firstPara_empty){
										firstPara_empty = false;
										paraendid = s;
									}
									if(firstPara_empty&&(!firstSen_empty)){
										firstPara_empty = false;
										
										paraendid = s;
									}
									char[] temp = new char[i - k];
									for (int j = 0; j < i - k; j++) {
										temp[j] = ctext[k + j];
									}
									String tmp = new String(temp);
									title1.append(tmp.replaceAll("\\{\\{[^\\{]*?\\}\\}", "") + "\t");
									i = i + 1;
									break;
								}
							}
						}
					} else if (ctext[i + 3] != '=') {
						if (ctext[i + 3] == ' ')
							i++;
						i = i + 2;
						k = i + 1;
						while (i < len) {
							i++;
							if(firstPara_empty){
								firstPara_empty = false;
								
								paraendid = s;
							}
							if ((ctext[i] == '=' && ctext[i + 1] == '=') || ctext[i] == '\n') {
								char[] temp = new char[i - k];
								for (int j = 0; j < i - k; j++) {
									temp[j] = ctext[k + j];
								}
								String tmp = new String(temp);
								title2.append(tmp.replaceAll("\\{\\{[^\\{]*?\\}\\}", "") + '\t');
								i = i + 2;
								break;
							}
						}
					} else if (ctext[i + 4] != '=') {
						if (ctext[i + 4] == ' ')
							i++;
						i = i + 3;
						k = i + 1;
						while (i < len) {
							i++;
							if ((ctext[i] == '=' && ctext[i + 1] == '=') || ctext[i] == '\n') {
								char[] temp = new char[i - k];
								for (int j = 0; j < i - k; j++) {
									temp[j] = ctext[k + j];
								}
								String tmp = new String(temp);
								title3.append(tmp.replaceAll("\\{\\{[^\\{]*?\\}\\}", "") + '\t');
								i = i + 3;
								break;
							}
						}
					} else if (ctext[i + 5] != '=') {
						if (ctext[i + 5] == ' ')
							i++;
						i = i + 4;
						k = i + 1;
						while (i < len) {
							i++;
							if ((ctext[i] == '=' && ctext[i + 1] == '=') || ctext[i] == '\n') {
								char[] temp = new char[i - k];
								for (int j = 0; j < i - k; j++) {
									temp[j] = ctext[k + j];
								}
								String tmp = new String(temp);
								title4.append(tmp.replaceAll("\\{\\{[^\\{]*?\\}\\}", "") + '\t');
								i = i + 4;
								break;
							}
						}
					}
					continue;
				}

				if (s == 0 && ctext[i] == '\n')
					continue;
				if (ctext[i] == '\n'&&s>0 && result[s - 1] == '\n')
					{
					if(firstPara_empty&&(!firstSen_empty)){
						//System.out.println(s+"  "+firstchar);
						if(s<firstchar+16);
						else{
						paraendid=s;
						firstPara_empty = false;
						}
					}
					continue;}
				if (ctext[i] == '\'')
					continue;
				if(ctext[i]==' '&&s>0&&result[s-1]==' ')continue;
				result[s] = ctext[i];
				s++;

			} // for loop ends
			if (title1.length() > 0) {
				subtitle_empty = false;
				// subtitle0.add(title1);
				section1title = title1.toString();
				title.append(title1.toString());
				if (title2.length() > 0) {
					// subtitle0.add(title2);
					title.append(title2.toString());
					if (title3.length() > 0) {
						// subtitle0.add(title3);
						title.append(title3.toString());
						if (title4.length() > 0) {
							// subtitle0.add(title4);
							title.append(title4.toString());
						}
					}
				}
			} else
				subtitle_empty = true;
			
			//if (!firstSen_empty) {
				if(result[0]=='\''||(result[0]>='A'&&result[0]<='Z')){firstchar = 0;firstSen_empty = false;}//!!!
				if (!firstSen_empty) {
				int countspace = 0; 
				while(result[firstchar]=='\n'||result[firstchar]==' ')firstchar++;
				int i = firstchar;
				
				while(countspace<4){
						if(result[firstchar]=='\n'||result[firstchar]==' '){firstchar++;i++;}//abc
						i++;
					if (i >= s) {
						firstSen_empty = true;
						firstSen = null;
						//throw new WikiException("瀵倸鐖剁�涙ê婀猣irstsen鐠囪褰囬張澶愭６妫版﹫绱癨n缁楊兛绔撮崣銉ㄧ樈濞屸剝婀�.\n");
					break;
					}
					if(result[i]=='('){
						int stackfir=1;
						k = i;
						while(i<len&&stackfir!=0){
							i++;
							if (i >= len) {
								//throw new WikiException("瀵倸鐖剁�涙ê婀猣irstsen鐠囪褰囬張澶愭６妫版﹫绱癨n瀹革附瀚崣锟�(濞屸剝婀佺�电懓绨查惃鍕礁閹奉剙褰縗n");
							break;
							}
							if(result[i]=='(')stackfir++;
							if(result[i]==')'){stackfir--;}
							if(result[i]=='\n') {break;}
						}
						if (i == len) {
							//throw new WikiException("瀵倸鐖剁�涙ê婀猣irstsen鐠囪褰囬張澶愭６妫版﹫绱癨n瀹革附瀚崣锟�(濞屸剝婀佺�电懓绨查惃鍕爱闁帮拷)\n");
						break;
						}
					}
					if ((i>5 && result[i] == '.')) {// U.S.
						if(result[i+2]=='.'&&result[i-1]=='i'&&result[i+1]=='e'){i=i+2;continue;}//i.e.
						if(result[i-4]==' '&&result[i-3]=='I'&&result[i-1]=='c'&&result[i-2]=='n')continue;// Inc.
						if(result[i+1]<=57 &&result[i+1]>=48)continue;
						if (result[i - 1] <= 90 && result[i - 1] >= 65 )
							{
							if(result[i - 2] <= 90 && result[i - 2] >= 65);
							else continue;}
						else if (result[i - 1] <= 122 && result[i - 1] >= 97){
							if(result[i-2]=='.')continue;
						if (result[i - 2] <= 90 && result[i - 2] >= 65){
						if((result[i-3]<=90&&result[i-3]>= 65)||(result[i - 3] <= 122 && result[i - 3] >= 97)||(result[i - 3] <= 57 && result[i - 3] >= 48)||result[i-3]=='-');
						else continue; // Dr.
						}
						}
						
						
						char[] temp = new char[i - firstchar + 1];
						int j = 0;
						for (j = 0; j < i - firstchar; j++) {
							temp[j] = result[firstchar + j];
							if(temp[j]==' '){
								countspace++;}
						}//the last char will ignore its countspace but remain its char value 
						temp[j] = result[firstchar + j];
						if(countspace<3||result[firstchar]=='|'){
							i++;
							firstchar = i;
						while(result[firstchar]=='\n'){
							firstchar++;
							i++;
						}
						countspace = 0;}
						else{
							firstSen = new String(temp);break;}
					}
					if(result[i]=='\n'&&i>4){
						
						if(((result[i-2]>='a'&&result[i-2]<='z')||result[i-2]==','||result[i-2]==')')&&result[i-1]==' '&&result[i+1]>='a'&&result[i+1]<='z'){
							//countspace = 2;
							continue;
							//revised 16/8/2016
						}
						if((result[i-1]==','||result[i-1]==')')&&result[i+1]>='a'&&result[i+1]<='z'){
							//countspace = 2;
							continue;
							//revised 16/8/2016
						}
						if(result[i-2]>='a'&&result[i-2]<='z'&&result[i-1]==' '&&result[i+1]>='a'&&result[i+1]<='z'){
							
							//countspace = 2;
							continue;
							//revised 16/8/2016
						}
						if(result[i+1]==')'||result[i+1]==','){
							//countspace= 2;
							continue;
						}
						int ii = i;
						if(result[i-1]==' ')ii=i-1;
						char[] temp = new char[ii - firstchar];
					    int j = 0;
						for (j = 0; j < ii - firstchar-1; j++) {
							temp[j] = result[firstchar + j];
							if(temp[j]==' '){
								countspace++;}
						}
						temp[j] = result[firstchar + j];
						if(result[ii-1]==':'){
							firstSen = new String(temp);break;
						}
						if(countspace<4||result[firstchar]=='|'){
							i++;
							firstchar = i;
							while(result[firstchar]=='\n'){
								firstchar++;
								i++;
							}
							countspace = 0;}
						else{firstSen = new String(temp);break;}
					}
					}
				
				if(paraendid == 0)
					{
					while(s>0&&(result[s-1]=='\n'||result[s-1]==' '))s--;
					paraendid = s;
					}
				if(paraendid - i <10){
					//if(paraendid-i<-1){ char[] tmp = new char[paraendid - i];}
					firstpara = firstSen;
				}else{
					i++;
					char[] tmp = new char[paraendid - i];
				for(int j = 0;j<paraendid-i;j++){
					tmp[j] = result[i+j];
				}
				firstpara =new String(tmp);
				}
				if(!firstPart_empty && firstpart_endid >0 ){
					
					char[] tmp = new char[firstpart_endid];
					for(int j = 0;j<firstpart_endid;j++){
						tmp[j] = result[j];
					
					firstPart =new String(tmp);
					}
				}//add 2018.3.30  add first part
				
				
				}//revised 16/8/2017
			// System.out.println("len is "+len+" s is "+s);
			
			while(s>0&&(result[s-1]==' '||result[s-1]=='\n')){
				s--;
			}
			char[] temp = new char[s];
			for (int j = 0; j < s; j++) {
				temp[j] = result[j];
			}
			content = new String(temp);
			
			if(firstPart_empty){
				firstPart = content;
				firstPart_empty = false;
			}//revised 31/3/2018  if there is no subsection title
			
			if (infobox0.length() == 0)
				infobox_empty = true;
			// error = error0.toString();
			infobox = infobox0.toString();
			subtitle = title.toString();
			if (category0.length() > 0) {
				category_empty = false;
				category = category0.toString();
			} else
				category_empty = true;
		} catch (Exception e) {
			throw e;
		}

	}

	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("firstsen=========================================\n");
		if (!firstSen_empty)
			builder.append("firstSen: " + firstSen + '\n');
		builder.append("firstpara=========================================\n");
		if(!firstPara_empty)builder.append("firstpara: "+firstpara + '\n');
		builder.append("infobox=========================================\n");
		if (!infobox_empty)
			builder.append("infobox:  " + infobox + '\n');
		builder.append("subtitle=========================================\n");
		if (!subtitle_empty)
			builder.append("subtitle:  " + subtitle + '\n');
		builder.append("category=========================================\n");
		if (!category_empty)
			builder.append("category:   " + category + '\n');
		builder.append("content=========================================\n");
		builder.append(content + '\n');
		
		return builder.toString();
	}
	public String getfirstPart() {
		if(firstPart!=null)
		return firstPart.replace("\n", "");
		else return "";
	}
	public String getFirstSen() {
		if(firstSen!=null)
		return firstSen.replace("\n", " ");
		else return "";
	}
	public String getFirstPara() {
		if(firstpara!=null)
		return firstpara.replace("\n", " ");
		else return "";
	}
	public String getcontent() {
		return content.replaceAll("\"", "");
	}

	public String getcontent_p() {
		if(content == null) return "";
		return content.replaceAll("[^a-zA-Z]+", " ").toLowerCase();
	}

	public String getInfobox() {
		if(infobox!=null)
		return infobox.replace("\n", " ");
		else return "";
	}

	public String getinfobox_p() {
		if (infobox_empty)
			return "";
		return infobox.replaceAll("[^a-zA-Z]+", " ").toLowerCase();
	}

	public String getCategory() {
		if(category!=null)
		return category.replace("\n", " ");
		else return "";
	}

	public String getCategory_p() {
		if (category_empty)
			return "";
		return category.replaceAll("[^a-zA-Z]+", " ").toLowerCase();
	}

	public String getfirstSubtitle() {
		if (subtitle_empty)
			return "";
		return section1title.replace("\n", " ");
	}
	public String getSubtitle() {
		if (subtitle_empty)
			return "";
		return subtitle;
	}
	public String getsubtitle_p() {
		if (subtitle_empty)
			return "";
		return subtitle.replaceAll("[^a-zA-Z]+", " ").toLowerCase();
	}

	public static void main(String[] args) {
		final String url = "jdbc:mysql://127.0.0.1:3308/wiki?useUnicode=true&characterEncoding=UTF-8&useSSL=false";
		final String name = "com.mysql.jdbc.Driver";
		final String user = "root";
		final String password = "V20erita_20s";
		try {
			Class.forName(name);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			System.err.println(e.getMessage());
			System.exit(1);
		}
		try (Connection conn = DriverManager.getConnection(url, user, password);
				PrintWriter ter = new PrintWriter(new OutputStreamWriter(
						new FileOutputStream("/media/sda3/veritas/Wikipedia/log1.txt"), "utf-8"));
				PrintWriter ter0 = new PrintWriter(new OutputStreamWriter(
						new FileOutputStream("/media/sda3/veritas/Wikipedia/log2.txt"), "utf-8"));

		) {
			Statement ps1 = conn.createStatement();
			ResultSet rs = ps1
					.executeQuery("select old_text,page_latest from article where page_latest = \"948994130\";");

			while (rs.next()) {                                          //Euglenozoawhere page_latest = 671565966
				System.out.println("title is "+rs.getString(2));
				ter.write(rs.getString(1));
				try {
					WikiText doc = new WikiText(rs.getString(1));
					// System.out.println(rs.getString(1));
					//ter0.write(doc.toString());
					System.out.println(doc.getFirstSen());
					if(doc.isRedi)System.out.println("redi");
					if(doc.isWikt)System.out.println("Wikt");
					if(Generate_Text.is_disambig(rs.getString(1)))System.out.println("disam");
					if(doc.firstSen_empty)System.out.println("empty");
					System.out.println(doc.toString());
					//System.out.println(rs.getString(1));
					//System.out.println(rs.getString(2));
					System.out.println(doc.getfirstSubtitle()+"AAAA");
					System.out.println(Removehtmlcode.remove(doc.getfirstSubtitle()));
					System.out.println(doc.getFirstPara()+"==");
					if(!doc.firstPart_empty)System.out.println("firstpart is "+doc.firstPart);
					//System.out.println(doc.toString());
					
				/*	
					String lvgConfigFile = "/Users/lishanyu/umls/lvg2015/data/config/lvg.properties";
					LuiNormApi nm = new LuiNormApi(lvgConfigFile);
					String[] tmp=doc.getcontent().split(" ");
					StringBuilder result = new StringBuilder();
					for(String a:tmp)result.append(nm.Mutate(a)+" ");
						System.out.println(result);
					
					*/
					
				} catch (Exception e) {
					e.printStackTrace();
					System.out.println("exceERROR:" + e.getMessage());
				}
				
			}

		} catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		} catch (SQLException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
	}

}
