import urllib.request
import urllib.parse
import lxml.etree

title_list = []
with open('Final_result.txt','r',encoding = 'utf8') as f:
    for x in f.readlines():
        temp_items = x.strip('\n').split('\t')
        title_list.append(temp_items[0])


def get_infobox(title_temp):
    try:
        try:
            response = urllib.request.urlopen('https://en.wikipedia.org/wiki/'+title_temp)
            text_temp = response.read().decode("utf-8",'ignore')
        except:
            url0 ='https://en.wikipedia.org/wiki/'+urllib.parse.quote(title_temp)
            response = urllib.request.urlopen(url0)
            text_temp = response.read().decode("utf-8",'ignore')
    except:
        return((title_temp,[]))
    #print(text_temp)
    result=lxml.etree.HTML(text_temp).xpath('//*[contains(@class,"infobox")]/tbody')
    result_tmp = []
    if len(result) == 0:
        pass
    else:
        for x in result[0].findall('tr'):
            temp_temp = []
            th_temp = x.findall('th')
            if len(th_temp) > 0:
                for y in th_temp:
                    if len(y.items())>0 and y.items()[0][1] == 'row':
                        if y.text != None:
                                temp_temp.append(y.text)
                        for z in y.findall('a'):
                            if z.text != None:
                                temp_temp.append(z.text)
                        for yy in x.findall('td'):
                            if yy.text != None:
                                temp_temp.append(yy.text)
                            for z in yy.findall('a'):
                                if z.text != None:
                                    temp_temp.append(z.text)
                            for z in yy.findall('b'):
                                if z.text != None:
                                    temp_temp.append(z.text)
                            for z in yy.findall('.//*/a'):
                                if z.text != None:
                                    temp_temp.append(z.text)
            else:
                td_temp = x.findall('td')
                if len(td_temp) >0:
                    for y in td_temp:
                        if y.text != None:
                            temp_temp.append(y.text)
                        for z in y.findall('a'):
                            if z.text != None:
                                temp_temp.append(z.text)
                        for z in y.findall('b'):
                            if z.text != None:
                                temp_temp.append(z.text)
                        for z in y.findall('.//*/a'):
                            if z.text != None:
                                temp_temp.append(z.text)
            if len(temp_temp) >0:
                result_tmp.append(temp_temp)
    return((title_temp,result_tmp))


count = 0
obtain_list = []
for title_temp in title_list:
    count += 1
    try:
        obtain_list.append(get_infobox(title_temp))
    except:
        print(title_temp)
    if count % 5000 ==0:
        print(count)
print(count)


with open('./obtained_infobox.txt','w',encoding = 'utf8') as f:
    f.write(str(obtain_list))